// Add a style tag to the document's head for the map's styling
import injectCSS from './util/inject-css';
import Map from './map';
import Layer from './layer';
import GeoJSONLayer from './geojson-layer';
import Feature from './feature';
import ZoomControl from './zoom-control';
import Popup from './popup';
import ScaleControl from './scale-control';
import Marker from './marker';
import Source from './source';
import Cluster from './cluster';
import RotationControl from './rotation-control';

injectCSS(window);

export {
  Feature,
  Layer,
  GeoJSONLayer,
  Map,
  Popup,
  ZoomControl,
  ScaleControl,
  Marker,
  Source,
  Cluster,
  RotationControl
};

export default Map;
